(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      4897,        173]*)
(*NotebookOutlinePosition[      5565,        196]*)
(*  CellTagsIndexPosition[      5521,        192]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Christoffel", "ObjectName"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["Christoffel",
    FontFamily->"Courier"],
  " is a reserved word in ",
  StyleBox["xTensor`",
    FontFamily->"Courier"],
  ". It is used to generate (using ",
  StyleBox["GiveSymbol",
    FontFamily->"Courier"],
  ") the name of the Christoffel tensor relating two covariant derivatives.\n\
\[FilledSmallSquare] ",
  StyleBox["Christoffel",
    FontFamily->"Courier"],
  "[",
  StyleBox["CD",
    FontSlant->"Italic"],
  "][",
  StyleBox["inds",
    FontSlant->"Italic"],
  "] is automatically converted into ",
  StyleBox["Christoffel",
    FontFamily->"Courier"],
  "[",
  StyleBox["CD",
    FontSlant->"Italic"],
  ", ",
  StyleBox["PD",
    FontFamily->"Courier"],
  "][",
  StyleBox["inds",
    FontSlant->"Italic"],
  "].",
  "\n\[FilledSmallSquare] ",
  StyleBox["Christoffel",
    FontFamily->"Courier"],
  "[",
  StyleBox["CD1, CD2",
    FontSlant->"Italic"],
  "][",
  StyleBox["inds",
    FontSlant->"Italic"],
  "] is automatically converted into ",
  StyleBox["GiveSymbol",
    FontFamily->"Courier"],
  "[",
  StyleBox["Christoffel",
    FontFamily->"Courier"],
  ", ",
  StyleBox["CD1, CD2",
    FontSlant->"Italic"],
  "][",
  StyleBox["inds",
    FontSlant->"Italic"],
  "] if the list {",
  StyleBox["CD1",
    FontSlant->"Italic"],
  ", ",
  StyleBox["CD2",
    FontSlant->"Italic"],
  "} is sorted, or into -",
  StyleBox["GiveSymbol",
    FontFamily->"Courier"],
  "[",
  StyleBox["Christoffel",
    FontFamily->"Courier"],
  ", ",
  StyleBox["CD2, CD1",
    FontSlant->"Italic"],
  "][",
  StyleBox["inds",
    FontSlant->"Italic"],
  "] otherwise."
}], "Usage"],

Cell[TextData[{
  "\[FilledSmallSquare] The derivatives are sorted lexicographically, except \
for ",
  StyleBox["PD",
    FontFamily->"Courier"],
  " which is always sorted last.\n\[FilledSmallSquare] Two derivatives ",
  StyleBox["CD1",
    FontSlant->"Italic"],
  " and ",
  StyleBox["CD2",
    FontSlant->"Italic"],
  " can be related by a Christoffel tensor if and only if they are compatible \
(this is checked using the private function ",
  StyleBox["CompatibleCovDsQ",
    FontFamily->"Courier"],
  "[",
  StyleBox["CD1, CD2",
    FontSlant->"Italic"],
  "]), defined as follows: two derivatives are compatible iff one of them (or \
both) is PD and either one of them (or both) does not act on any internal \
vbundle or both act on the same internal vbundle.\n\[FilledSmallSquare] See: \
",
  ButtonBox["Section 4.5",
    ButtonData:>{
      FrontEnd`FileName[ {
        ParentDirectory[ ]}, "xTensorRefGuide.nb", CharacterEncoding -> 
        "iso8859-1"], "Covariant derivatives"},
    ButtonStyle->"Hyperlink"],
  ".\n\[FilledSmallSquare] See also: ",
  StyleBox[ButtonBox["GiveSymbol",
    ButtonData:>{"GiveSymbol.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  StyleBox[".",
    FontFamily->"Courier"],
  "\n\[FilledSmallSquare] New in version 0.\n\[FilledSmallSquare] Last \
update: 17-X-2007 for version 0.9.3 of ",
  StyleBox["xTensor`",
    FontFamily->"Courier"],
  "."
}], "Text"]
}, Open  ]]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowSize->{520, 600},
WindowMargins->{{103, Automatic}, {47, Automatic}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 33, 0, 38, "ObjectName"],
Cell[1812, 55, 1640, 73, 140, "Usage"],
Cell[3455, 130, 1426, 40, 224, "Text"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

